#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SeniorGraphicalCFG.h"
std::auto_ptr<Fish_SeniorGraphicalCFG> Fish_SeniorGraphicalCFG::msSingleton(nullptr);

int Fish_SeniorGraphicalCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SeniorGraphicalCFGData* Fish_SeniorGraphicalCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SeniorGraphicalCFGData>& Fish_SeniorGraphicalCFG::GetMapData()
{
	return mMapData;
}

void Fish_SeniorGraphicalCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SeniorGraphicalCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SeniorGraphicalCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mGraphicalId = element->Attribute("GraphicalId");
		data.mGraphicalMultiple = element->IntAttribute("GraphicalMultiple");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SeniorGraphicalCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorGraphicalCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SeniorGraphicalCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SeniorGraphicalCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SeniorGraphicalCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "GraphicalId", data.mGraphicalId);
		LuaCfgHelper::readInt(L, "GraphicalMultiple", data.mGraphicalMultiple);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SeniorGraphicalCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SeniorGraphicalCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SeniorGraphicalCFG* Fish_SeniorGraphicalCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SeniorGraphicalCFG());
	}
	return msSingleton.get();
}

void Fish_SeniorGraphicalCFG::Release()
{
	msSingleton.reset(nullptr);
}
